##    Radio Free Pete -- streaming Internet jukebox for the masses
##    Copyright (C) 2001 Peter Gautier
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 2 of the License, or
##    (at your option) any later version.
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from Persistence import Persistent
from math import sqrt

class Track(Persistent):
	""" class for extending the Track ZClass """

	def __init__(self):
		pass

	def get_weight(self):
		if not self.num_ratings:
			rating = 4 # Low default number should exaggerate higher ratings
		else:
			rating = float(self.rating_total) / float(self.num_ratings)
		rating = rating + int(sqrt(self.num_requests) - (self.num_skips / 10))
		ret = int(rating * rating)
		if ret < 1: ret = 1
		return ret
